'''
This code runs a two-dimensional K-Means example.
The data are taken from Burak Kanber's example (in Javascript):
    http://burakkanber.com/blog/machine-learning-k-means-clustering-in-javascript-part-1/
The code uses SciPy's kmeans2 implementation.

@author: kvlinden
@version Jan 14, 2013
'''

from scipy.cluster.vq import kmeans2
from matplotlib.pyplot import scatter, show
import numpy

# Set up the parameters.
k = 3
data = numpy.array([[1, 2], [2, 1], [2, 4], [1, 3], [2, 2], [3, 1], [1, 1], [7, 3], [8, 2], [6, 4], [7, 4], [8, 1], [9, 2], [10, 8], [9, 10], [7, 8], [7, 9], [8, 11], [9, 9]])

# Run K-Means.
centers, classifications = kmeans2(data, k)

# Print the results
print 'Cluster centers:\n' + str(centers)
print 'Data point classifications:\n' + str(classifications)

# Plot the results. Note that the color list has more than enough colors for up to len(colors) clusters.
colors = ('red', 'blue', 'green', 'yellow', 'purple', 'orange', 'black')  
scatter(data[:, 0], data[:, 1], color=[colors[i] for i in classifications])
show()
